// Generated by rstantools.  Do not edit by hand.

/*
    FlexReg is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FlexReg is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FlexReg.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MODELS_HPP
#define MODELS_HPP
#define STAN__SERVICES__COMMAND_HPP
#ifndef USE_STANC3
#define USE_STANC3
#endif
#include <rstan/rstaninc.hpp>
// Code generated by stanc v2.32.2
#include <stan/model/model_header.hpp>
namespace model_Bin_namespace {
using stan::model::model_base_crtp;
using namespace stan::math;
stan::math::profile_map profiles__;
static constexpr std::array<const char*, 39> locations_array__ =
  {" (found before start of program)",
  " (in 'Bin', line 12, column 1 to column 16)",
  " (in 'Bin', line 15, column 1 to column 32)",
  " (in 'Bin', line 42, column 1 to column 19)",
  " (in 'Bin', line 24, column 2 to column 27)",
  " (in 'Bin', line 23, column 6 to line 24, column 27)",
  " (in 'Bin', line 22, column 2 to column 29)",
  " (in 'Bin', line 21, column 6 to line 24, column 27)",
  " (in 'Bin', line 20, column 2 to column 21)",
  " (in 'Bin', line 19, column 6 to line 24, column 27)",
  " (in 'Bin', line 18, column 2 to column 27)",
  " (in 'Bin', line 17, column 1 to line 24, column 27)",
  " (in 'Bin', line 44, column 2 to column 120)",
  " (in 'Bin', line 43, column 14 to line 45, column 2)",
  " (in 'Bin', line 43, column 1 to line 45, column 2)",
  " (in 'Bin', line 32, column 3 to column 40)",
  " (in 'Bin', line 31, column 7 to line 32, column 40)",
  " (in 'Bin', line 30, column 3 to column 40)",
  " (in 'Bin', line 29, column 2 to line 32, column 40)",
  " (in 'Bin', line 28, column 16 to line 33, column 2)",
  " (in 'Bin', line 28, column 1 to line 33, column 2)",
  " (in 'Bin', line 37, column 1 to column 60)",
  " (in 'Bin', line 36, column 14 to line 38, column 2)",
  " (in 'Bin', line 36, column 1 to line 38, column 2)",
  " (in 'Bin', line 2, column 1 to column 16)",
  " (in 'Bin', line 3, column 7 to column 8)",
  " (in 'Bin', line 3, column 1 to column 16)",
  " (in 'Bin', line 4, column 7 to column 8)",
  " (in 'Bin', line 4, column 1 to column 16)",
  " (in 'Bin', line 5, column 1 to column 16)",
  " (in 'Bin', line 6, column 8 to column 9)",
  " (in 'Bin', line 6, column 10 to column 11)",
  " (in 'Bin', line 6, column 1 to column 15)",
  " (in 'Bin', line 7, column 1 to column 27)",
  " (in 'Bin', line 8, column 1 to column 30)",
  " (in 'Bin', line 9, column 1 to column 22)",
  " (in 'Bin', line 12, column 8 to column 9)",
  " (in 'Bin', line 15, column 25 to column 26)",
  " (in 'Bin', line 42, column 8 to column 9)"};
#include <stan_meta_header.hpp>
class model_Bin final : public model_base_crtp<model_Bin> {
private:
  int N;
  std::vector<int> n;
  std::vector<int> y;
  int K;
  Eigen::Matrix<double,-1,-1> X_data__;
  int link_code_mu;
  int link_prior_beta;
  double hyperprior_beta;
  Eigen::Map<Eigen::Matrix<double,-1,-1>> X{nullptr, 0, 0};
public:
  ~model_Bin() {}
  model_Bin(stan::io::var_context& context__, unsigned int random_seed__ = 0,
            std::ostream* pstream__ = nullptr) : model_base_crtp(0) {
    int current_statement__ = 0;
    using local_scalar_t__ = double;
    boost::ecuyer1988 base_rng__ =
      stan::services::util::create_rng(random_seed__, 0);
    // suppress unused var warning
    (void) base_rng__;
    static constexpr const char* function__ =
      "model_Bin_namespace::model_Bin";
    // suppress unused var warning
    (void) function__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      current_statement__ = 24;
      context__.validate_dims("data initialization", "N", "int",
        std::vector<size_t>{});
      N = std::numeric_limits<int>::min();
      current_statement__ = 24;
      N = context__.vals_i("N")[(1 - 1)];
      current_statement__ = 24;
      stan::math::check_greater_or_equal(function__, "N", N, 1);
      current_statement__ = 25;
      stan::math::validate_non_negative_index("n", "N", N);
      current_statement__ = 26;
      context__.validate_dims("data initialization", "n", "int",
        std::vector<size_t>{static_cast<size_t>(N)});
      n = std::vector<int>(N, std::numeric_limits<int>::min());
      current_statement__ = 26;
      n = context__.vals_i("n");
      current_statement__ = 27;
      stan::math::validate_non_negative_index("y", "N", N);
      current_statement__ = 28;
      context__.validate_dims("data initialization", "y", "int",
        std::vector<size_t>{static_cast<size_t>(N)});
      y = std::vector<int>(N, std::numeric_limits<int>::min());
      current_statement__ = 28;
      y = context__.vals_i("y");
      current_statement__ = 29;
      context__.validate_dims("data initialization", "K", "int",
        std::vector<size_t>{});
      K = std::numeric_limits<int>::min();
      current_statement__ = 29;
      K = context__.vals_i("K")[(1 - 1)];
      current_statement__ = 29;
      stan::math::check_greater_or_equal(function__, "K", K, 1);
      current_statement__ = 30;
      stan::math::validate_non_negative_index("X", "N", N);
      current_statement__ = 31;
      stan::math::validate_non_negative_index("X", "K", K);
      current_statement__ = 32;
      context__.validate_dims("data initialization", "X", "double",
        std::vector<size_t>{static_cast<size_t>(N), static_cast<size_t>(K)});
      X_data__ = Eigen::Matrix<double,-1,-1>::Constant(N, K,
                   std::numeric_limits<double>::quiet_NaN());
      new (&X) Eigen::Map<Eigen::Matrix<double,-1,-1>>(X_data__.data(), N, K);
      {
        std::vector<local_scalar_t__> X_flat__;
        current_statement__ = 32;
        X_flat__ = context__.vals_r("X");
        current_statement__ = 32;
        pos__ = 1;
        current_statement__ = 32;
        for (int sym1__ = 1; sym1__ <= K; ++sym1__) {
          current_statement__ = 32;
          for (int sym2__ = 1; sym2__ <= N; ++sym2__) {
            current_statement__ = 32;
            stan::model::assign(X, X_flat__[(pos__ - 1)],
              "assigning variable X", stan::model::index_uni(sym2__),
              stan::model::index_uni(sym1__));
            current_statement__ = 32;
            pos__ = (pos__ + 1);
          }
        }
      }
      current_statement__ = 33;
      context__.validate_dims("data initialization", "link_code_mu", "int",
        std::vector<size_t>{});
      link_code_mu = std::numeric_limits<int>::min();
      current_statement__ = 33;
      link_code_mu = context__.vals_i("link_code_mu")[(1 - 1)];
      current_statement__ = 33;
      stan::math::check_greater_or_equal(function__, "link_code_mu",
        link_code_mu, 1);
      current_statement__ = 34;
      context__.validate_dims("data initialization", "link_prior_beta",
        "int", std::vector<size_t>{});
      link_prior_beta = std::numeric_limits<int>::min();
      current_statement__ = 34;
      link_prior_beta = context__.vals_i("link_prior_beta")[(1 - 1)];
      current_statement__ = 34;
      stan::math::check_greater_or_equal(function__, "link_prior_beta",
        link_prior_beta, 1);
      current_statement__ = 35;
      context__.validate_dims("data initialization", "hyperprior_beta",
        "double", std::vector<size_t>{});
      hyperprior_beta = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 35;
      hyperprior_beta = context__.vals_r("hyperprior_beta")[(1 - 1)];
      current_statement__ = 36;
      stan::math::validate_non_negative_index("beta", "K", K);
      current_statement__ = 37;
      stan::math::validate_non_negative_index("mu", "N", N);
      current_statement__ = 38;
      stan::math::validate_non_negative_index("log_lik", "N", N);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
    num_params_r__ = K;
  }
  inline std::string model_name() const final {
    return "model_Bin";
  }
  inline std::vector<std::string> model_compile_info() const noexcept {
    return std::vector<std::string>{"stanc_version = stanc3 v2.32.2",
             "stancflags = --allow-undefined"};
  }
  template <bool propto__, bool jacobian__, typename VecR, typename VecI,
            stan::require_vector_like_t<VecR>* = nullptr,
            stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline stan::scalar_type_t<VecR>
  log_prob_impl(VecR& params_r__, VecI& params_i__, std::ostream*
                pstream__ = nullptr) const {
    using T__ = stan::scalar_type_t<VecR>;
    using local_scalar_t__ = T__;
    T__ lp__(0.0);
    stan::math::accumulator<T__> lp_accum__;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    static constexpr const char* function__ = "model_Bin_namespace::log_prob";
    // suppress unused var warning
    (void) function__;
    try {
      Eigen::Matrix<local_scalar_t__,-1,1> beta =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(K, DUMMY_VAR__);
      current_statement__ = 1;
      beta = in__.template read<Eigen::Matrix<local_scalar_t__,-1,1>>(K);
      Eigen::Matrix<local_scalar_t__,-1,1> mu =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(N, DUMMY_VAR__);
      current_statement__ = 11;
      if (stan::math::logical_eq(link_code_mu, 1)) {
        current_statement__ = 10;
        stan::model::assign(mu,
          stan::math::inv_logit(stan::math::multiply(X, beta)),
          "assigning variable mu");
      } else {
        current_statement__ = 9;
        if (stan::math::logical_eq(link_code_mu, 2)) {
          current_statement__ = 8;
          stan::model::assign(mu,
            stan::math::Phi(stan::math::multiply(X, beta)),
            "assigning variable mu");
        } else {
          current_statement__ = 7;
          if (stan::math::logical_eq(link_code_mu, 3)) {
            current_statement__ = 6;
            stan::model::assign(mu,
              stan::math::inv_cloglog(stan::math::multiply(X, beta)),
              "assigning variable mu");
          } else {
            current_statement__ = 5;
            if (stan::math::logical_eq(link_code_mu, 4)) {
              current_statement__ = 4;
              stan::model::assign(mu,
                stan::math::exp(
                  stan::math::minus(
                    stan::math::exp(stan::math::multiply(X, beta)))),
                "assigning variable mu");
            }
          }
        }
      }
      current_statement__ = 2;
      stan::math::check_greater_or_equal(function__, "mu", mu, 0);
      current_statement__ = 2;
      stan::math::check_less_or_equal(function__, "mu", mu, 1);
      {
        current_statement__ = 20;
        for (int l = 1; l <= K; ++l) {
          current_statement__ = 18;
          if (stan::math::logical_eq(link_prior_beta, 1)) {
            current_statement__ = 17;
            lp_accum__.add(stan::math::normal_lpdf<propto__>(
                             stan::model::rvalue(beta, "beta",
                               stan::model::index_uni(l)), 0, hyperprior_beta));
          } else {
            current_statement__ = 16;
            if (stan::math::logical_eq(link_prior_beta, 2)) {
              current_statement__ = 15;
              lp_accum__.add(stan::math::cauchy_lpdf<propto__>(
                               stan::model::rvalue(beta, "beta",
                                 stan::model::index_uni(l)), 0,
                               hyperprior_beta));
            }
          }
        }
        current_statement__ = 23;
        for (int i = 1; i <= N; ++i) {
          current_statement__ = 21;
          lp_accum__.add(((stan::model::rvalue(y, "y",
                             stan::model::index_uni(i)) *
            stan::math::log(
              stan::model::rvalue(mu, "mu", stan::model::index_uni(i)))) +
            ((stan::model::rvalue(n, "n", stan::model::index_uni(i)) -
            stan::model::rvalue(y, "y", stan::model::index_uni(i))) *
            stan::math::log((1 -
              stan::model::rvalue(mu, "mu", stan::model::index_uni(i)))))));
        }
      }
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
    lp_accum__.add(lp__);
    return lp_accum__.sum();
  }
  template <typename RNG, typename VecR, typename VecI, typename VecVar,
            stan::require_vector_like_vt<std::is_floating_point,
            VecR>* = nullptr, stan::require_vector_like_vt<std::is_integral,
            VecI>* = nullptr, stan::require_vector_vt<std::is_floating_point,
            VecVar>* = nullptr>
  inline void
  write_array_impl(RNG& base_rng__, VecR& params_r__, VecI& params_i__,
                   VecVar& vars__, const bool
                   emit_transformed_parameters__ = true, const bool
                   emit_generated_quantities__ = true, std::ostream*
                   pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    stan::io::serializer<local_scalar_t__> out__(vars__);
    static constexpr bool propto__ = true;
    // suppress unused var warning
    (void) propto__;
    double lp__ = 0.0;
    // suppress unused var warning
    (void) lp__;
    int current_statement__ = 0;
    stan::math::accumulator<double> lp_accum__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    constexpr bool jacobian__ = false;
    static constexpr const char* function__ =
      "model_Bin_namespace::write_array";
    // suppress unused var warning
    (void) function__;
    try {
      Eigen::Matrix<double,-1,1> beta =
        Eigen::Matrix<double,-1,1>::Constant(K,
          std::numeric_limits<double>::quiet_NaN());
      current_statement__ = 1;
      beta = in__.template read<Eigen::Matrix<local_scalar_t__,-1,1>>(K);
      Eigen::Matrix<double,-1,1> mu =
        Eigen::Matrix<double,-1,1>::Constant(N,
          std::numeric_limits<double>::quiet_NaN());
      out__.write(beta);
      if (stan::math::logical_negation(
            (stan::math::primitive_value(emit_transformed_parameters__) ||
            stan::math::primitive_value(emit_generated_quantities__)))) {
        return ;
      }
      current_statement__ = 11;
      if (stan::math::logical_eq(link_code_mu, 1)) {
        current_statement__ = 10;
        stan::model::assign(mu,
          stan::math::inv_logit(stan::math::multiply(X, beta)),
          "assigning variable mu");
      } else {
        current_statement__ = 9;
        if (stan::math::logical_eq(link_code_mu, 2)) {
          current_statement__ = 8;
          stan::model::assign(mu,
            stan::math::Phi(stan::math::multiply(X, beta)),
            "assigning variable mu");
        } else {
          current_statement__ = 7;
          if (stan::math::logical_eq(link_code_mu, 3)) {
            current_statement__ = 6;
            stan::model::assign(mu,
              stan::math::inv_cloglog(stan::math::multiply(X, beta)),
              "assigning variable mu");
          } else {
            current_statement__ = 5;
            if (stan::math::logical_eq(link_code_mu, 4)) {
              current_statement__ = 4;
              stan::model::assign(mu,
                stan::math::exp(
                  stan::math::minus(
                    stan::math::exp(stan::math::multiply(X, beta)))),
                "assigning variable mu");
            }
          }
        }
      }
      current_statement__ = 2;
      stan::math::check_greater_or_equal(function__, "mu", mu, 0);
      current_statement__ = 2;
      stan::math::check_less_or_equal(function__, "mu", mu, 1);
      if (emit_transformed_parameters__) {
        out__.write(mu);
      }
      if (stan::math::logical_negation(emit_generated_quantities__)) {
        return ;
      }
      Eigen::Matrix<double,-1,1> log_lik =
        Eigen::Matrix<double,-1,1>::Constant(N,
          std::numeric_limits<double>::quiet_NaN());
      current_statement__ = 14;
      for (int i = 1; i <= N; ++i) {
        current_statement__ = 12;
        stan::model::assign(log_lik,
          ((((stan::math::lgamma(
                (stan::model::rvalue(n, "n", stan::model::index_uni(i)) + 1))
          -
          stan::math::lgamma(
            (stan::model::rvalue(y, "y", stan::model::index_uni(i)) + 1))) -
          stan::math::lgamma(
            ((stan::model::rvalue(n, "n", stan::model::index_uni(i)) -
            stan::model::rvalue(y, "y", stan::model::index_uni(i))) + 1))) +
          (stan::model::rvalue(y, "y", stan::model::index_uni(i)) *
          stan::math::log(
            stan::model::rvalue(mu, "mu", stan::model::index_uni(i))))) +
          ((stan::model::rvalue(n, "n", stan::model::index_uni(i)) -
          stan::model::rvalue(y, "y", stan::model::index_uni(i))) *
          stan::math::log((1 -
            stan::model::rvalue(mu, "mu", stan::model::index_uni(i)))))),
          "assigning variable log_lik", stan::model::index_uni(i));
      }
      out__.write(log_lik);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  template <typename VecVar, typename VecI,
            stan::require_vector_t<VecVar>* = nullptr,
            stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline void
  unconstrain_array_impl(const VecVar& params_r__, const VecI& params_i__,
                         VecVar& vars__, std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    stan::io::serializer<local_scalar_t__> out__(vars__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      Eigen::Matrix<local_scalar_t__,-1,1> beta =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(K, DUMMY_VAR__);
      current_statement__ = 1;
      stan::model::assign(beta,
        in__.read<Eigen::Matrix<local_scalar_t__,-1,1>>(K),
        "assigning variable beta");
      out__.write(beta);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  template <typename VecVar, stan::require_vector_t<VecVar>* = nullptr>
  inline void
  transform_inits_impl(const stan::io::var_context& context__, VecVar&
                       vars__, std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::serializer<local_scalar_t__> out__(vars__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      current_statement__ = 1;
      context__.validate_dims("parameter initialization", "beta", "double",
        std::vector<size_t>{static_cast<size_t>(K)});
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      Eigen::Matrix<local_scalar_t__,-1,1> beta =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(K, DUMMY_VAR__);
      {
        std::vector<local_scalar_t__> beta_flat__;
        current_statement__ = 1;
        beta_flat__ = context__.vals_r("beta");
        current_statement__ = 1;
        pos__ = 1;
        current_statement__ = 1;
        for (int sym1__ = 1; sym1__ <= K; ++sym1__) {
          current_statement__ = 1;
          stan::model::assign(beta, beta_flat__[(pos__ - 1)],
            "assigning variable beta", stan::model::index_uni(sym1__));
          current_statement__ = 1;
          pos__ = (pos__ + 1);
        }
      }
      out__.write(beta);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  inline void
  get_param_names(std::vector<std::string>& names__, const bool
                  emit_transformed_parameters__ = true, const bool
                  emit_generated_quantities__ = true) const {
    names__ = std::vector<std::string>{"beta"};
    if (emit_transformed_parameters__) {
      std::vector<std::string> temp{"mu"};
      names__.reserve(names__.size() + temp.size());
      names__.insert(names__.end(), temp.begin(), temp.end());
    }
    if (emit_generated_quantities__) {
      std::vector<std::string> temp{"log_lik"};
      names__.reserve(names__.size() + temp.size());
      names__.insert(names__.end(), temp.begin(), temp.end());
    }
  }
  inline void
  get_dims(std::vector<std::vector<size_t>>& dimss__, const bool
           emit_transformed_parameters__ = true, const bool
           emit_generated_quantities__ = true) const {
    dimss__ = std::vector<std::vector<size_t>>{std::vector<size_t>{static_cast<
                                                                    size_t>(K)}};
    if (emit_transformed_parameters__) {
      std::vector<std::vector<size_t>>
        temp{std::vector<size_t>{static_cast<size_t>(N)}};
      dimss__.reserve(dimss__.size() + temp.size());
      dimss__.insert(dimss__.end(), temp.begin(), temp.end());
    }
    if (emit_generated_quantities__) {
      std::vector<std::vector<size_t>>
        temp{std::vector<size_t>{static_cast<size_t>(N)}};
      dimss__.reserve(dimss__.size() + temp.size());
      dimss__.insert(dimss__.end(), temp.begin(), temp.end());
    }
  }
  inline void
  constrained_param_names(std::vector<std::string>& param_names__, bool
                          emit_transformed_parameters__ = true, bool
                          emit_generated_quantities__ = true) const final {
    for (int sym1__ = 1; sym1__ <= K; ++sym1__) {
      param_names__.emplace_back(std::string() + "beta" + '.' +
        std::to_string(sym1__));
    }
    if (emit_transformed_parameters__) {
      for (int sym1__ = 1; sym1__ <= N; ++sym1__) {
        param_names__.emplace_back(std::string() + "mu" + '.' +
          std::to_string(sym1__));
      }
    }
    if (emit_generated_quantities__) {
      for (int sym1__ = 1; sym1__ <= N; ++sym1__) {
        param_names__.emplace_back(std::string() + "log_lik" + '.' +
          std::to_string(sym1__));
      }
    }
  }
  inline void
  unconstrained_param_names(std::vector<std::string>& param_names__, bool
                            emit_transformed_parameters__ = true, bool
                            emit_generated_quantities__ = true) const final {
    for (int sym1__ = 1; sym1__ <= K; ++sym1__) {
      param_names__.emplace_back(std::string() + "beta" + '.' +
        std::to_string(sym1__));
    }
    if (emit_transformed_parameters__) {
      for (int sym1__ = 1; sym1__ <= N; ++sym1__) {
        param_names__.emplace_back(std::string() + "mu" + '.' +
          std::to_string(sym1__));
      }
    }
    if (emit_generated_quantities__) {
      for (int sym1__ = 1; sym1__ <= N; ++sym1__) {
        param_names__.emplace_back(std::string() + "log_lik" + '.' +
          std::to_string(sym1__));
      }
    }
  }
  inline std::string get_constrained_sizedtypes() const {
    return std::string("[{\"name\":\"beta\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(K) + "},\"block\":\"parameters\"},{\"name\":\"mu\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(N) + "},\"block\":\"transformed_parameters\"},{\"name\":\"log_lik\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(N) + "},\"block\":\"generated_quantities\"}]");
  }
  inline std::string get_unconstrained_sizedtypes() const {
    return std::string("[{\"name\":\"beta\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(K) + "},\"block\":\"parameters\"},{\"name\":\"mu\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(N) + "},\"block\":\"transformed_parameters\"},{\"name\":\"log_lik\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(N) + "},\"block\":\"generated_quantities\"}]");
  }
  // Begin method overload boilerplate
  template <typename RNG> inline void
  write_array(RNG& base_rng, Eigen::Matrix<double,-1,1>& params_r,
              Eigen::Matrix<double,-1,1>& vars, const bool
              emit_transformed_parameters = true, const bool
              emit_generated_quantities = true, std::ostream*
              pstream = nullptr) const {
    const size_t num_params__ = K;
    const size_t num_transformed = emit_transformed_parameters * (N);
    const size_t num_gen_quantities = emit_generated_quantities * (N);
    const size_t num_to_write = num_params__ + num_transformed +
      num_gen_quantities;
    std::vector<int> params_i;
    vars = Eigen::Matrix<double,-1,1>::Constant(num_to_write,
             std::numeric_limits<double>::quiet_NaN());
    write_array_impl(base_rng, params_r, params_i, vars,
      emit_transformed_parameters, emit_generated_quantities, pstream);
  }
  template <typename RNG> inline void
  write_array(RNG& base_rng, std::vector<double>& params_r, std::vector<int>&
              params_i, std::vector<double>& vars, bool
              emit_transformed_parameters = true, bool
              emit_generated_quantities = true, std::ostream*
              pstream = nullptr) const {
    const size_t num_params__ = K;
    const size_t num_transformed = emit_transformed_parameters * (N);
    const size_t num_gen_quantities = emit_generated_quantities * (N);
    const size_t num_to_write = num_params__ + num_transformed +
      num_gen_quantities;
    vars = std::vector<double>(num_to_write,
             std::numeric_limits<double>::quiet_NaN());
    write_array_impl(base_rng, params_r, params_i, vars,
      emit_transformed_parameters, emit_generated_quantities, pstream);
  }
  template <bool propto__, bool jacobian__, typename T_> inline T_
  log_prob(Eigen::Matrix<T_,-1,1>& params_r, std::ostream* pstream = nullptr) const {
    Eigen::Matrix<int,-1,1> params_i;
    return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
  }
  template <bool propto__, bool jacobian__, typename T_> inline T_
  log_prob(std::vector<T_>& params_r, std::vector<int>& params_i,
           std::ostream* pstream = nullptr) const {
    return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
  }
  inline void
  transform_inits(const stan::io::var_context& context,
                  Eigen::Matrix<double,-1,1>& params_r, std::ostream*
                  pstream = nullptr) const final {
    std::vector<double> params_r_vec(params_r.size());
    std::vector<int> params_i;
    transform_inits(context, params_i, params_r_vec, pstream);
    params_r = Eigen::Map<Eigen::Matrix<double,-1,1>>(params_r_vec.data(),
                 params_r_vec.size());
  }
  inline void
  transform_inits(const stan::io::var_context& context, std::vector<int>&
                  params_i, std::vector<double>& vars, std::ostream*
                  pstream__ = nullptr) const {
    vars.resize(num_params_r__);
    transform_inits_impl(context, vars, pstream__);
  }
  inline void
  unconstrain_array(const std::vector<double>& params_constrained,
                    std::vector<double>& params_unconstrained, std::ostream*
                    pstream = nullptr) const {
    const std::vector<int> params_i;
    params_unconstrained = std::vector<double>(num_params_r__,
                             std::numeric_limits<double>::quiet_NaN());
    unconstrain_array_impl(params_constrained, params_i,
      params_unconstrained, pstream);
  }
  inline void
  unconstrain_array(const Eigen::Matrix<double,-1,1>& params_constrained,
                    Eigen::Matrix<double,-1,1>& params_unconstrained,
                    std::ostream* pstream = nullptr) const {
    const std::vector<int> params_i;
    params_unconstrained = Eigen::Matrix<double,-1,1>::Constant(num_params_r__,
                             std::numeric_limits<double>::quiet_NaN());
    unconstrain_array_impl(params_constrained, params_i,
      params_unconstrained, pstream);
  }
};
}
using stan_model = model_Bin_namespace::model_Bin;
#ifndef USING_R
// Boilerplate
stan::model::model_base&
new_model(stan::io::var_context& data_context, unsigned int seed,
          std::ostream* msg_stream) {
  stan_model* m = new stan_model(data_context, seed, msg_stream);
  return *m;
}
stan::math::profile_map& get_stan_profile_data() {
  return model_Bin_namespace::profiles__;
}
#endif
#endif
